package sorts;

import util.OArrays;

/**
 * Sort.java
 * Created by Stijn Strickx on May 21, 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */

/**
 * The datatype conversions for the arrays won't influence 
 * the time complexity of the sorting algorithms.
 * Without these conversions,
 * the algorithms would have to be re-written for every primitive datatype.
 */

public class Sort {
    
    public static <T extends Comparable<? super T>> void shellSort(T[] a){
        (new ShellSort()).sort(a);
    }
    public static int[] shellSort(int[] a){
        Integer[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static long[] shellSort(long[] a){
        Long[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static double[] shellSort(double[] a){
        Double[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static float[] shellSort(float[] a){
        Float[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static char[] shellSort(char[] a){
        Character[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static boolean[] shellSort(boolean[] a){
        Boolean[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
    public static byte[] shellSort(byte[] a){
        Byte[] b = OArrays.toObjectArray(a);
        shellSort(b);
        return OArrays.toPrimitiveArray(b);
    }
}